# A description of what this defined type does
#
# @summary A short summary of the purpose of this defined type.
#
# @example
#   openldap::server::globalconf { 'namevar': }
define openldap::server::globalconf(
  $value,
  $ensure = present,
) {
  # Ensure the main server class has been defined
  if !defined(Class['openldap::server']) {
    fail 'Class openldap::server not defined'
  }

  # Set processing order
  if $openldap::server::provider == 'olc' {
    Class['openldap::server::service']
    -> Openldap::Server::Globalconf[$title]
    -> Class['openldap::server']
  } else {
    Openldap::Server::Globalconf[$title]
    ~> Class['openldap::server::service']
  }

  # Create an instance of the Ruby type
  openldap_global_conf { $name:
    ensure   => $ensure,
    provider => $openldap::server::provider,
    target   => $openldap::server::config_file,
    value    => $value,
  }
}
